use std::iter::Sum;

use crate::bitboard::{Bitboard, square};
use crate::movegen::BitboardIterator;


pub const PAWN_PST: PieceSquareTable<i16> = PieceSquareTable{
    board:
    [
        0; 64
    ]
};


pub struct PieceSquareTable<T: Sum + Copy> {
    pub board: [T; 64],
}


impl<T: Sum + Copy> PieceSquareTable<T> {
    pub fn score_bitboard(&self, b: Bitboard) -> T {
        BitboardIterator(b).map(|bit| self.board[square(bit) as usize]).sum()
    }
}
